/*

 SAMPLE.PRG
 Programa ejemplos de la librera TNO351

 Compilar :
               clipper sample /n/w

 Linkeditar:
               rtlink fi sample, NT2US50 li nt250, tno351, objects

 Program ejemplo por Guillermo Gisinger

*/

#include 'TNO3501.CH'


*- Funcin principal
FUNC Main()
   LOCAL oMenu, oPad, oPop, oPop2, oBar, cOpcion := '01.01'

   *- Seteo la aplicacin
   setcursor( 0 )
   setblink( .F. )
   setcolor( IF( iscolor(), 'g+/n,+bg/b,,,+gr/n', 'w/n,+u,,,+w/n' ) )
   wsetshadow( '+n/n' )
   set( _SET_SCOREBOARD, 'OFF' )
   set( _SET_WRAP, 'ON' )

   *- Dibujo la pantalla
   CLS
   @ 00, 00 SAY space( maxcol() + 1 ) COLOR 'i'
   dispbox( 01, 00, maxrow() - 3, maxcol(), repl( '', 9 ), 'w/n' )
   @ maxrow() - 2, 00 SAY padr( ' Programa ejemplo :  SAMPLE.PRG', 40 ) + ;
   padl( CharDate( date() ) + ' ', 40 ) COLOR 'i'

   *- Defino un nuevo objeto MENU
   oMenu := TMenu():New( 'i,+w/n' )

   *- Defino el primer PAD
   oPad := TPad():New( '  Gets  ', 00, 02 )

   *- Defino el POPUP para el primer PAD
   oPop := TPopup():New( 02, 01 )

   *- Empiezo ha agregarle las barras
   oPop:addbar( TBar():New( ' &Super get (ejemplo de un mdulo de ALTAS) ' ) )

   *- Asigno el POPUP al PAD
   oPad:popup := oPop

   *- Agrego el primer PAD al MENU
   oMenu:addpad( oPad )

   *- Hago lo mismo para los dems PADS
   oPad := TPad():New( '  Browses  ', 00, 10 )
      oPop := TPopup():New( 02, 07 )
      oPop:addbar( TBar():New( ' &Tablas - Cmo hacer un browse con una tabla? ' ) )
      oPop:addbar( TBar():New( ' Te&xtos - Cmo hacer un browse con un archivo? ' ) )
      oPop:addbar( TBar():New( repl( '', 55 ), .F. ) )
      oPop:addbar( TBar():New( ' Textos &2 - Una forma extraa de mirar un archivo ' ) )
   oPad:popup := oPop
   oMenu:addpad( oPad )

   oPad := TPad():New( '  Informacin  ', 00, 21 )
      oPop := TPopup():New( 02, 24 )
      oBar := TBar():New( ' Informacin ' ) 
         oPop2 := TPopup():New( 04, 30 )
         oPop2:addbar( TBar():New( ' &Autor ' ) )
         oPop2:addbar( TBar():New( ' &Dirigirse a ... ' ) )
         oPop2:addbar( TBar():New( ' &Versin ' ) )
      oBar:popup := oPop2
      oPop:addbar( oBar )
   oPad:popup := oPop
   oMenu:addpad( oPad )                

   *- Asgino el ultimo PAD. No contiene POPUP
   oMenu:addpad( TPad():New( '  Salir!  ', 00, maxcol() - 11 ) )

   *- Blanqueo las variables ya que no sern usadas
   oPad := oPop := oPop2 := oBar := Nil

   KeyDesc( 'TNO351.LIB - Una librera para tener en cuenta ...' )

   WHILE cOpcion != '04'  // Mientras no sea SALIR
      *- Si se presiona ESCAPE
      IF cOpcion == '00'
         cOpcion := '04'       // Reposiciono el menu en SALIR
      ENDIF

      *- Activo el menu
      cOpcion := ActivateMenu( oMenu, val( left( cOpcion, 2 ) ), ;
      val( substr( cOpcion, 4, 2 ) ) )

      *- Muestro la opcin elegida
      Message( 'Usted eligi la opcin ' + cOpcion )
      TNOInkey( 0 )
      wclose()

      DO CASE                
         CASE cOpcion == '01.01'
            Altas()
         CASE cOpcion = '02.01'
            BrowArray()
         CASE cOpcion = '02.02'
            BrwTexto()
         CASE cOpcion == '02.04'
            TextoInfo()
         CASE cOpcion == '03.01.01'
            Alerta( 'El autor de esta fantstica librera es :;Guillermo Gisinger', ;
            ' Grande pibe !! ' )
         CASE cOpcion == '03.01.02'
            Message( 'Dirigirse a :; ;' + padr( 'Boulogne Sur Mer 53', 30 ) + ';' + ;
            padr( 'Longchamps  -  C.P. 1854', 30 ) + ';' + ;
            padr( 'Buenos Aires  -  Argentina', 30 ) )
            inkey( 0 )
            wclose()
         CASE cOpcion == '03.01.03'
            Alerta( 'Esta es la versin 3 para Clipper 5.01,;aunque tambin funciona con ' + ;
            'Clipper 5.2 y las Tools III.', ' Bueno ; Esta bien ; Lo que vos digas ' )
      ENDCASE
   ENDDO
   CLS
   setcolor( 'w/n' )
RETURN ( Nil )

/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

STAT FUNC BrwTexto()
   LOCAL aLift, oTxt, nLast, nKey := 0, oCol, cLine

   DISPBEGIN()         
       cLine := KeyDesc( '-Recorrer;PgUp-Retrocede;PgDn-Avanza;Home-Principio;End-Fin' )
       wopen( 00, 00, 15, 60, .T. )
       wcenter( .T. )
       dispbox( 00, 00, maxrow(), maxcol(), B_SIMPLE )
       @ 00, 03 SAY ' Browse de un texto ' COLOR GetColor( 5 )
   DISPEND()

   FT_FUse( 'SAMPLE.PRG' ) 
   nLast := FT_FlastRec()

   oTxt := tbrowsenew( 02, 01, maxrow() - 1, maxcol() - 2 )
   oTxt:gotopblock := { || FT_FGoTop() }
   oTxt:skipblock := { | n | TextSkip( n, FT_FRecno(), nLast ) }
   oTxt:gobottomblock := { || FT_FGoTo( nLast ) }

   oCol := tbcolumnnew( '', { || FT_FReadLn() } )
   oCol:width := maxcol() - 1

   oTxt:addcolumn( oCol )

   WHILE nKey != K_ESC
      WHILE !oTxt:stabilize()
      ENDDO          

      DISPBEGIN()
         aLift := Lift( ft_frecno() - oTxt:rowpos + 1, maxrow() - 2, ;
         nLast, maxrow() - 1 )

         @ 00, maxcol() SAY '' ;
         COLOR GetColor( IF( aLift[ 1 ], 1, 5 ) )

         @ maxrow(), maxcol() SAY '' ;
         COLOR GetColor( IF( aLift[ 2 ], 1, 5 ) )

         dispbox( 01, maxcol(), maxrow() - 1, maxcol(), '' )

         dispbox( aLift[ 3 ], maxcol() , aLift[ 4 ], maxcol(), ;
         '', GetColor( 5 ) )
      DISPEND()

      IF oTxt:hittop .OR. oTxt:hitbottom
         sound( 75, 1 )
         oTxt:hittop := oTxt:hitbottom := .F.
      ENDIF

      nKey := TNOInkey( 0 )

      DO CASE
         CASE nKey == K_UP
            oTxt:up()
         CASE nKey == K_DOWN
            oTxt:down()
         CASE nKey == K_PGUP
            oTxt:pageup()
         CASE nKey == K_PGDN
            oTxt:pagedown()
         CASE nKey == K_HOME
            oTxt:gotop()
         CASE nKey == K_END
            oTxt:gobottom()
      ENDCASE
   ENDDO                   
   ft_fuse()
   wclose()
   RestKeys( cLine )
RETURN ( Nil )

/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

STAT FUNC TextoInfo()
   LOCAL oTxt, oCol, nKey := 0, aLift, aWhen[ 7 ], nFrom := 1
   LOCAL aButton[ 7 ], aWind := {}, nLast, GetList := {}
   LOCAL cColor := IF( iscolor(), 'n/w,*n/w,n/b', '*n/w,*n/w,n/w' )

   ft_fuse( 'SAMPLE.PRG' )
   nLast := FT_FLastRec()

   afill( aWhen, .F. )
   afill( aButton, .F. )

   aWhen[ 1 ] := .T.

   DISPBEGIN()
      aadd( aWind, wopen( 02, 01, 20, 44, .T. ) )
      dispbox( 00, 00, maxrow(), maxcol(), B_SIMPLE )
      @ 00, 03 SAY ' Texto: SAMPLE.PRG ' COLOR GetColor( 5 )

      oTxt := tbrowsenew( 02, 01, maxrow() - 1, maxcol() - 2 )
      oTxt:gotopblock := { || ft_fgotop() }
      oTxt:skipblock := { | n | TextSkip( n, ft_frecno(), nLast ) }
      oTxt:gobottomblock := { || ft_fgoto( nLast ) }

      oCol := tbcolumnnew( '', { || substr( ft_freadln(), nFrom ) } )
      oCol:width := maxcol() - 2
      oTxt:addcolumn( oCol )

      aadd( aWind, wopen( 02, 47, 20, 78, .T. ) )
      dispbox( 00, 00, maxrow(), maxcol(), B_SIMPLE )
      dispbox( 01, 01, maxrow() - 1, maxcol() - 1, space( 9 ), ;
      IF( iscolor(), 'b/b', 'i' ) )
      @ 02, 03 GET aButton[ 1 ] BUTTON '     Avanzar pgina      ' COLOR cColor ;
      WHEN aWhen[ 1 ] .AND. ( afill( aWhen, .T. ), .T. )
      @ 04, 03 GET aButton[ 2 ] BUTTON '    Retroceder pgina    ' COLOR cColor ;
      WHEN aWhen[ 2 ] .AND. ( afill( aWhen, .T. ), .T. )
      @ 06, 03 GET aButton[ 3 ] BUTTON '  Principio de archivo   ' COLOR cColor ;
      WHEN aWhen[ 3 ] .AND. ( afill( aWhen, .T. ), .T. )
      @ 08, 03 GET aButton[ 4 ] BUTTON '     Fin de archivo      ' COLOR cColor ;
      WHEN aWhen[ 4 ] .AND. ( afill( aWhen, .T. ), .T. )
      @ 10, 03 GET aButton[ 5 ] BUTTON '   Scroll a la derecha   ' COLOR cColor ;
      WHEN aWhen[ 5 ] .AND. ( afill( aWhen, .T. ), .T. )
      @ 12, 03 GET aButton[ 6 ] BUTTON '  Scroll a la izquierda  ' COLOR cColor ;
      WHEN aWhen[ 6 ] .AND. ( afill( aWhen, .T. ), .T. )
      @ 16, 03 GET aButton[ 7 ] BUTTON '         Terminar        ' COLOR cColor 
   DISPEND()

   wselect( aWind[ 1 ] )
   WHILE .T.
      WHILE !oTxt:stabilize()
      ENDDO

      DISPBEGIN()
         aLift := Lift( ft_frecno() - oTxt:rowpos + 1, maxrow() - 2, ;
         nLast, maxrow() - 1 )

         @ 00, maxcol() SAY '' ;
         COLOR GetColor( IF( aLift[ 1 ], 1, 5 ) )

         @ maxrow(), maxcol() SAY '' ;
         COLOR GetColor( IF( aLift[ 2 ], 1, 5 ) )

         dispbox( 01, maxcol(), maxrow() - 1, maxcol(), '' )

         dispbox( aLift[ 3 ], maxcol() , aLift[ 4 ], maxcol(), ;
         '', GetColor( 5 ) )
      DISPEND()

      IF oTxt:hittop .OR. oTxt:hitbottom
         sound( 75, 1 )
         oTxt:hittop := oTxt:hitbottom := .F.
      ENDIF

      wselect( aWind[ 2 ] )
      IF GoodRead( @GetList, .F. ) .AND. !aButton[ 7 ]
         wselect( aWind[ 1 ] )
         DO CASE
            CASE aButton[ 1 ]
               oTxt:pagedown()
            CASE aButton[ 2 ]
               oTxt:pageup()
            CASE aButton[ 3 ]
               oTxt:gotop()
            CASE aButton[ 4 ]
               oTxt:gobottom()
            CASE aButton[ 5 ]
               nFrom += 5
               oTxt:refreshall()
            CASE aButton[ 6 ]
               IF ( nFrom -= 5 ) < 1
                  nFrom := 1
               ENDIF
               oTxt:refreshall()
         ENDCASE
         aWhen := aclone( aButton )
         afill( aButton, .F. )
      ELSE
         EXIT
      ENDIF
   ENDDO
   ft_fuse()
   aeval( aWind, { | w | wselect( w ), wclose() } )
RETURN ( Nil )

/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

STAT FUNC Altas()
   LOCAL GetList := {}, aDatos[ 8 ], cScr
   LOCAL aRadio := { 'Soltero    ', 'Casado     ', 'Divorciado ', 'Viudo      ' }
   LOCAL aDocu := MDBFill( 'DOCUMENT.DAT',, { 1, 2 } )
   LOCAL aCiudad := MToA( MDBFILL( 'CIUDAD.DAT',, { 1 } ), { | _1 | _1[ 1 ] } )
   DISPBEGIN()
      wopen( 00, 00, 17, 60, .T. )
      wmove( 03, 02 )
      dispbox( 00, 00, maxrow(), maxcol(), B_SIMPLE )
      @ 02, 03 SAY 'Apellido y nombre'
      @ 04, 03 SAY 'Tipo de documento'
      @ 05, 03 SAY 'Nmero de documento'
      @ 07, 03 SAY 'Estudios cursados'
      @ 11, 03 SAY 'Estado civil'
      @ 11, 25 SAY 'Localidad :'
   DISPEND()
   cScr := savescreen( 00, 00, maxrow(), maxcol() )
   WHILE .T.                                       
      restscreen( 00, 00, maxrow(), maxcol(), cScr )

      aDatos := { space( 30 ), 0, 0, .T., .F., .F., 2, 1 }

      @ 02, 24 GETT aDatos[ 1 ] PICTURE '@!'

      @ 04, 24 GETT aDatos[ 2 ] PICTURE '@Z 99' HELP HlpDocu( aDocu ) WHEN !empty( aDatos[ 1 ] ) ;
      VALID lastkey() == K_UP .OR. DocumentOk( aDatos[ 2 ], aDocu )

      @ 05, 24 GETT aDatos[ 3 ] PICTURE '@ZE 99,999,999' WHEN !empty( aDatos[ 1 ] ) ;
      VALID lastkey() == K_UP .OR. !empty( aDatos[ 3 ] )

      @ 07, 24 GET aDatos[ 4 ] CHECK 'Primaria      ' WHEN !empty( aDatos[ 1 ] )
      @ 08, 24 GET aDatos[ 5 ] CHECK 'Secundaria    ' WHEN !empty( aDatos[ 1 ] )
      @ 09, 24 GET aDatos[ 6 ] CHECK 'Universitaria ' WHEN !empty( aDatos[ 1 ] )

      @ 13, 04 GET aDatos[ 7 ] RADIO aRadio WHEN !empty( aDatos[ 1 ] )

      @ 12, 25 GET aDatos[ 8 ] LISTBOX aCiudad WHEN !empty( aDatos[ 1 ] ) ;
      SIZE 3,30

      IF GoodRead( @GetList ) .AND. !empty( aDatos[ 1 ] )
         IF Alerta( 'Estn todos los datos bien?', '  Si  ;  No  ',, 02, 43  ) == 1
            Alerta( 'Aqui se graban los datos !!!' )
         ENDIF
      ELSE
         EXIT
      ENDIF
   ENDDO
   wclose()
RETURN ( Nil )


STAT FUNC HlpDocu( aDocu )
   LOCAL nOpcion
   nOpcion := AChoose( ' Documentos ', MToA( aDocu, { | d | d[ 2 ] } ) )
   IF nOpcion != 0
      nOpcion := aDocu[ nOpcion, 1 ]
   ELSE
      nOpcion := Nil
   ENDIF
RETURN ( nOpcion )

STAT FUNC DocumentOk( nDoc, aDocu )
   LOCAL nFind, lOk := .F.
   nFind := ascan( aDocu, { | d | d[ 1 ] == nDoc } )
   IF nFind != 0
      @ row(), col() + 2 SAY aDocu[ nDoc, 2 ] COLOR GetColor( 5 )
      lOk := .T.
   ELSE         
      Alerta( 'El cdigo ingresado no existe !!!' )
   ENDIF
RETURN ( lOk )

/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\

STAT FUNC BrowArray()
   LOCAL oBrow, nKey, nPos := 1, aFiles := directory( '*.*' )

   DISPBEGIN()
      wopen( 00, 00, 16, 60, .T. )
      wcenter( .T. )
      dispbox( 00, 00, maxrow(), maxcol(), 1 )
   DISPEND()           

   oBrow := tbrowsenew( 01, 01, maxrow(), maxcol() - 1 )
   oBrow:headsep := ''
   oBrow:colsep := '  '
   oBrow:footsep := ''
   oBrow:colorspec := 'w/n,' + IF( iscolor(), '+gr/g', 'i' )

   oBrow:gotopblock := { || nPos := 1 }
   oBrow:gobottomblock := { || nPos := len( aFiles ) }
   oBrow:skipblock := { | skip | ArraySkip( skip, @nPos, len( aFiles ) ) }

   oBrow:addcolumn( tbcolumnnew( 'Nombre', { || padr( aFiles[ nPos, 1 ], 12 ) } ) )
   oBrow:addcolumn( tbcolumnnew( 'Bytes', { || str( aFiles[ nPos, 2 ], 10 ) } ) )
   oBrow:addcolumn( tbcolumnnew( 'Fecha', { || dtoc( aFiles[ nPos, 3 ] ) } ) )
   oBrow:addcolumn( tbcolumnnew( 'Hora', { || aFiles[ nPos, 4 ] } ) )

   WHILE .T.
      WHILE !oBrow:stabilize()
      ENDDO
      IF oBrow:hittop .OR. oBrow:hitbottom
         sound( 75, 1 )
         oBrow:hittop := oBrow:hitbottom := .F.
      ENDIF

      nKey := TNOInkey( 0 )

      DO CASE
         CASE nKey == K_ESC
            EXIT
         CASE nKey == K_UP
            oBrow:up()
         CASE nKey == K_DOWN
            oBrow:down()
         CASE nKey == K_PGUP
            oBrow:pageup()
         CASE nKey == K_PGDN
            oBrow:pagedown()
         CASE nKey == K_HOME
            oBrow:gotop()
         CASE nKey == K_END
            oBrow:gobottom()
         CASE nKey == K_LEFT
            oBrow:left()
         CASE nKey == K_RIGHT
            oBrow:right()
      ENDCASE
   ENDDO
   wclose()
RETURN ( Nil )

/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
/////////////////////////////////////\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
